local jkCiderProduction = ...

--------------------------------------------------------------------------
local COMP_JK_ACTIVATOR = {
    TypeName = "COMP_JK_ACTIVATOR",
    ParentType = "COMPONENT",
    Properties = {
        { Name = "EmitterNodeName", Type = "string", Default = "EMITTER_NODE_NAME" },
        { Name = "ComponentToActivate", Type = "string", Default = "LINKED_COMPONENT" }
	}
}

--------------------------------------------------------------------------
function COMP_JK_ACTIVATOR:init()
    self.timer = 0
    self.emitter = nil
    self.emitterInitialized = false
    self.linkedComponent = nil
end

--------------------------------------------------------------------------
function COMP_JK_ACTIVATOR:update()
    if self.timer >= 0 then
        local dt = self:getLevel():getDeltaTime()
        self.timer = self.timer - dt
    elseif self.timer < 0 then
        if self.emitterInitialized == false then
            self:getOwner():forEachChild(
                function(child)
                    if child.Name == self.EmitterNodeName then
                        self.emitter = child:getComponent("COMP_PARTICLE_EMITTER")
                    elseif child.Name == self.ComponentToActivate then
                        self.linkedComponent = child
                    end
                end
            )
            self.emitterInitialized = true
        end
        if self.emitter and self.linkedComponent then
            self.linkedComponent.Active = self.emitter.IsEmitting
        end
        self.timer = 1
    end
end

--------------------------------------------------------------------------
jkCiderProduction:registerClass(COMP_JK_ACTIVATOR)