local jkCiderProduction = ...

APPLE_FARM_SEASON_CONFIG = {
    SOWING_DURATION_END = 1,
    GROW_DURATION_END = 10,
    GROW_WAIT_DURATION_END = 11,
    HARVEST_DURATION_END = 19,
    REST_DURATION_END = 21
}

--------------------------------------------------------------------------
local COMP_APPLE_FARM_STATE_TRACKER = {
    TypeName = MOD_NS .. "COMP_APPLE_FARM_STATE_TRACKER",
    ParentType = "COMPONENT",
    Properties = {
        { Name = "Day", Type = "integer", Default = 1, Flags = { "SAVE_GAME" }},
    }
}

function COMP_APPLE_FARM_STATE_TRACKER:reset()
    self.Day = 1
end

local sowEnd = APPLE_FARM_SEASON_CONFIG.SOWING_DURATION_END
local growEnd = APPLE_FARM_SEASON_CONFIG.GROW_WAIT_DURATION_END
local harvestEnd = APPLE_FARM_SEASON_CONFIG.HARVEST_DURATION_END
--------------------------------------------------------------------------
function COMP_APPLE_FARM_STATE_TRACKER:init()
    local compMainGameLoop = self:getLevel():find("COMP_MAIN_GAME_LOOP")

    event.register(self, compMainGameLoop.ON_NEW_DAY, function()
        self.Day = self.Day + 1
        -- not needed as long as the reset function should is called at the start of each season
        -- self.Day = self.Day % 21
        jkCiderProduction:log(tostring(APPLE_FARM_SEASON_CONFIG.SOWING_DURATION_END))

        self:getLevel():getComponentManager(MOD_NS .. "COMP_APPLE_TREE"):getAllComponent():forEach(function(appleTreeCmp)
            appleTreeCmp:getOwner():forEachChild(
                function(child)
                    if child.Name == "Apples" then
                        if self.Day < growEnd or self.Day > harvestEnd then
                            child.Active = false
                        else 
                            child.Active = true
                        end
                    elseif child.Name == "Branches_03_Apples" then
                        if self.Day >= 6 and self.Day < growEnd then
                            child.Active = true
                        else 
                            child.Active = false
                        end
                    elseif child.Name == "Branches_01" then
                        if self.Day > sowEnd and self.Day < 4  then
                            child.Active = true
                        else
                            child.Active = false
                        end
                    elseif child.Name == "Branches_02" then
                        if self.Day >= 4 and self.Day < 8 then
                            child.Active = true
                        else
                            child.Active = false
                        end
                    elseif child.Name == "Branches_03" then
                        if self.Day >= 8 and self.Day <= harvestEnd then
                            child.Active = true
                        else
                            child.Active = false
                        end
                    end
                end
            )
        end)
    end)
end

--------------------------------------------------------------------------
function COMP_APPLE_FARM_STATE_TRACKER:update()
end


--------------------------------------------------------------------------
jkCiderProduction:registerClass(COMP_APPLE_FARM_STATE_TRACKER)
jkCiderProduction:registerPrefabComponent("PREFAB_MANAGER", { DataType = MOD_NS .. "COMP_APPLE_FARM_STATE_TRACKER" } )

local COMP_APPLE_TREE = {
    TypeName = MOD_NS .. "COMP_APPLE_TREE",
    ParentType = "COMPONENT"
}

function COMP_APPLE_TREE:init()
    self:getLevel():getComponentManager(MOD_NS .. "COMP_APPLE_FARM_STATE_TRACKER"):getAllComponent():forEach(function(farmStateTracker)
        farmStateTracker:reset()
    end)
    self:getOwner():forEachChild(function(child)
        if child.Name ~= "Branches" then 
            child.Active = false
        end
    end)
end

jkCiderProduction:registerClass(COMP_APPLE_TREE)