local jkCiderProduction = ...

jkCiderProduction:registerAssetId("models/hut.fbx/Materials/transparent_roof", MOD_NS .. "TRANSPARENT_ROOF")
jkCiderProduction:override({
    Id = MOD_NS .. "TRANSPARENT_ROOF",
	HasTransparency = true,
	HasAlphaTest = true,
	BackFaceVisible = true,
	HasShadow = true
})

jkCiderProduction:registerAssetId("models/hut.fbx/Materials/apples_2", MOD_NS .. "APPLES_PILE_2")
jkCiderProduction:override({
    Id = MOD_NS .. "APPLES_PILE_2",
	HasTransparency = true,
	HasAlphaTest = true,
	BackFaceVisible = true,
	HasShadow = true
})

jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/HutPart", MOD_NS .. "PREFAB_HUT")
jkCiderProduction:registerAssetProcessor("models/hut.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

jkCiderProduction:registerPrefabComponent("models/hut.fbx/Prefab/HutPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {4, 6}
})

jkCiderProduction:register({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "HUT_PART",
	Description = "",
	ConstructionVisual = MOD_NS .. "PREFAB_HUT",
	AssetBuildingFunction = MOD_NS .. "BREWER_FUNCTION",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {9, 6}, {1, -0.5} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = MOD_NS .. "PREFAB_HUT"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 4 }
		},
		RessourcesNeeded = {
			{ Resource = "PLANK", Quantity = 25 },
			{ Resource = "STONE", Quantity = 10 }
		}
	}
})

jkCiderProduction:register({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "ROOT_PART",
	Description = "",
	ConstructionVisual = "PREFAB_RESOURCE_VISUAL_CRATE",
	IsMonumentCore = true,
	IsVisibleWhenBuilt = false,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_RESOURCE_VISUAL_CRATE"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 0 }
		}
	}
})

jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/HutPart/FrontPart", MOD_NS .. "CIDER_BREWERY_FRONT_PART")
jkCiderProduction:registerPrefabComponent("models/hut.fbx/Prefab/HutPart/FrontPart", {
	DataType = "COMP_GROUNDED"
})
jkCiderProduction:configurePrefabFlagList("models/hut.fbx/Prefab/HutPart/FrontPart", { "PLATFORM" })
jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/HutPart/FrontPart/VapourEmitter", MOD_NS .. "VAPOUR_EMITTER_PREFAB")
jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/HutPart/FrontPart/FireEmitter", MOD_NS .. "FIRE_EMITTER_PREFAB")
jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/HutPart/FrontPart/PATH_A_1", MOD_NS .. "CIDER_BREWERY_PATHA1")
jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/HutPart/FrontPart/PATH_A_2", MOD_NS .. "CIDER_BREWERY_PATHA2")
jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/HutPart/FrontPart/PATH_A_3", MOD_NS .. "CIDER_BREWERY_PATHA3")
jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/HutPart/FrontPart/PATH_A_4", MOD_NS .. "CIDER_BREWERY_PATHA4")
jkCiderProduction:registerPrefabComponent("models/hut.fbx/Prefab/HutPart/FrontPart", {
	DataType = "COMP_JK_ACTIVATOR",
	EmitterNodeName = "VapourEmitter",
	ComponentToActivate = "BoilingCider"
}) 
jkCiderProduction:registerPrefabComponent("models/hut.fbx/Prefab/HutPart/FrontPart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
		{
			MOD_NS .. "VAPOUR_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE"
		}, {
			MOD_NS .. "FIRE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE"
		}
	},
	PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { MOD_NS .. "CIDER_BREWERY_PATHA1", MOD_NS .. "CIDER_BREWERY_PATHA2", MOD_NS .. "CIDER_BREWERY_PATHA3", MOD_NS .. "CIDER_BREWERY_PATHA4" }
		},
		{
            PathType = BUILDING_PATH_TYPE.WORK,
            WayPointList = { MOD_NS .. "CIDER_BREWERY_PATHA1", MOD_NS .. "CIDER_BREWERY_PATHA2", MOD_NS .. "CIDER_BREWERY_PATHA3", MOD_NS .. "CIDER_BREWERY_PATHA4" }
		}
	}
})
jkCiderProduction:registerPrefabComponent("models/hut.fbx/Prefab/HutPart/FrontPart/VapourEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})
jkCiderProduction:registerPrefabComponent("models/hut.fbx/Prefab/HutPart/FrontPart/VapourEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_SAWMILL_SMOKE",
	IsPlaying = false,
	IsEmitting = false
})

jkCiderProduction:registerPrefabComponent("models/hut.fbx/Prefab/HutPart/FrontPart/FireEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})
jkCiderProduction:registerPrefabComponent("models/hut.fbx/Prefab/HutPart/FrontPart/FireEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_BLACKSMITH_FIRE",
	IsPlaying = false,
	IsEmitting = false
})

jkCiderProduction:register({
	DataType = "BUILDING_FUNCTION_WAREHOUSE",
	Id = MOD_NS .. "APPLE_STORAGE_FUNCTION",
	SocketCount = 1,
	SocketCapacity = 500,
	RelatedJob = { Job = "TRANSPORTER", Behavior = "BEHAVIOR_TRANSPORT" },
	AllowedResourceTypeList = {
		"RESOURCE_TYPE_APPLE"
	},
	DefaultResourceVisual = "PREFAB_RESOURCE_BERRIES"
})

jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/CabinPart", MOD_NS .. "PREFAB_CABIN")
jkCiderProduction:register({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "CABIN_PART",
	Description = "",
	ConstructionVisual = MOD_NS .. "PREFAB_CABIN",
	AssetBuildingFunction = "BUILDING_FUNCTION_APPLE_FARM",
	Capacity = 100,
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {3, 3}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = MOD_NS .. "PREFAB_CABIN"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 2 }
		},
		RessourcesNeeded = {
			{ Resource = "PLANK", Quantity = 10 }
		}
	}
})
jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/CabinPart/ShovelPart", MOD_NS .. "PREFAB_SHOVEL")
jkCiderProduction:registerPrefabComponent("models/hut.fbx/Prefab/CabinPart/ShovelPart", {
	DataType = "COMP_GROUNDED"
})

jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/Storage", MOD_NS .. "PREFAB_STORAGE")
jkCiderProduction:register({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "STORAGE_PART",
	Description = "",
	ConstructionVisual = MOD_NS .. "PREFAB_STORAGE",
	Capacity = 150,
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {8, 5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = MOD_NS .. "PREFAB_STORAGE"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 4 }
		},
		RessourcesNeeded = {
			{ Resource = "PLANK", Quantity = 20 }
		}
	}
})

jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/Storage_B", MOD_NS .. "PREFAB_STORAGE_B")
jkCiderProduction:register({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "STORAGE_B_PART",
	Description = "",
	ConstructionVisual = MOD_NS .. "PREFAB_STORAGE_B",
	Capacity = 213,
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {9, 3}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = MOD_NS .. "PREFAB_STORAGE_B"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 2 }
		},
		RessourcesNeeded = {
			{ Resource = "PLANK", Quantity = 20 }
		}
	}
})

jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/SmallPressPart", MOD_NS .. "PREFAB_SMALL_APPLE_PRESS")
jkCiderProduction:register({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "SMALL_APPLE_PRESS_PART",
	Description = "",
	ConstructionVisual = MOD_NS .. "PREFAB_SMALL_APPLE_PRESS",
	AssetBuildingFunction = MOD_NS .. "BREWER_FUNCTION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = MOD_NS .. "PREFAB_SMALL_APPLE_PRESS"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1, 1}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 2 }
		},
		RessourcesNeeded = {
			{ Resource = "PLANK", Quantity = 10 }
		}
	}
})

jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/BigPressPart", MOD_NS .. "PREFAB_BIG_APPLE_PRESS")
jkCiderProduction:register({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "BIG_APPLE_PRESS_PART",
	Description = "",
	ConstructionVisual = MOD_NS .. "PREFAB_BIG_APPLE_PRESS",
	AssetBuildingFunction = MOD_NS .. "BREWER_FUNCTION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = MOD_NS .. "PREFAB_BIG_APPLE_PRESS"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 1}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 2 }
		},
		RessourcesNeeded = {
			{ Resource = "PLANK", Quantity = 10 }
		}
	}
})

jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/ApplesPilePart", MOD_NS .. "PREFAB_APPLES_PILE")
jkCiderProduction:register({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "APPLES_PILE_PART",
	Description = "",
	ConstructionVisual = MOD_NS .. "PREFAB_APPLES_PILE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = MOD_NS .. "PREFAB_APPLES_PILE"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1 }
		},
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 1 }
		}
	}
})

jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/FullBucketPart", MOD_NS .. "PREFAB_FULL_BUCKET")
jkCiderProduction:register({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "FULL_BUCKET_PART",
	Description = "",
	ConstructionVisual = MOD_NS .. "PREFAB_FULL_BUCKET",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = MOD_NS .. "PREFAB_FULL_BUCKET"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1 }
		},
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 1 }
		}
	}
})

jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/EmptyBucketPart", MOD_NS .. "PREFAB_EMPTY_BUCKET")
jkCiderProduction:register({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "EMPTY_BUCKET_PART",
	Description = "",
	ConstructionVisual = MOD_NS .. "PREFAB_EMPTY_BUCKET",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = MOD_NS .. "PREFAB_EMPTY_BUCKET"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1 }
		},
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 1 }
		}
	}
})

jkCiderProduction:registerAssetId("models/hut.fbx/Prefab/EmptyBucket_2_Part", MOD_NS .. "PREFAB_EMPTY_BUCKET_2")
jkCiderProduction:register({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "EMPTY_BUCKET_2_PART",
	Description = "",
	ConstructionVisual = MOD_NS .. "PREFAB_EMPTY_BUCKET_2",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = MOD_NS .. "PREFAB_EMPTY_BUCKET_2"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1 }
		},
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 1 }
		}
	}
})

jkCiderProduction:registerAssetId("models/platform.fbx/Prefab/PlatformPart", MOD_NS .. "PREFAB_PLATFORM")
jkCiderProduction:registerAssetProcessor("models/platform.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
jkCiderProduction:configurePrefabFlagList("models/platform.fbx/Prefab/PlatformPart", { "PLATFORM" })
jkCiderProduction:register({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "PLATFORM_PART",
	Description = "",
	ConstructionVisual = MOD_NS .. "PREFAB_PLATFORM",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {8, 5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = MOD_NS .. "PREFAB_PLATFORM"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1 }
		},
		RessourcesNeeded = {
			{ Resource = "PLANK", Quantity = 15 }
		}
	}
})